# -*- coding: utf-8 -*-

import numpy as np
from scipy.interpolate import interp1d
from itertools import product

from dps import utils
from dps import darkphoton
from dps.distribution import gradation, get_step_limits

def sample(dp, kind, sample_size, z=None, kT=None,
           mesh=None, seed=None, args=None, set_coord=True, quiet=False):
    """
    Sample data inside the physical domain of the dark photon *dp* or along a
    cut of it according to a chosen distribution.

    Parameters
    ----------
    dp: dps.DarkPhoton
        DarkPhoton instance.
    kind: str
        Sample region or method. It must be "random": random covering of the
        physical domain, "regular": regular covering of the physical domain, or
        "cut": cut along the physical domain.
    sample_size: int or (int, int)
        Number of points to sample. Single valued if *kind* = "cut" or "random".
        Double valued if *kind* = "regular".
    z: float, optional
        Fixed value of the longitudinal fraction for the transverse cut. Needed
        only for *kind* = "cut". Only one of *z* and *kT* may not be None. Default
        is None.
    kT: float, optional
        Fixed value of the transverse momentum for the longitudinal cut. Needed
        only for *kind* = "cut". Only one of "z* and *kT* may not be None. Default
        is None.
    mesh: str, optional
        Distribution of the points: "constant" or "gaussian". Needed only for
        *kind* = "regular" or "cut". Default is None.
    seed: int, optional
        Seed of the random number generator. Only for *kind* = "random". Default
        is None.
    args: dict, optional
        Dictionnary of the arguments for the gaussian cut if *mesh* = "gaussian".
        If None, the default dictionnary generated by *gaussian_args()* is used.
        Default is None.
    set_coord: bool, optional
        If True the attributes *dp.z* and *dp.kT* are set to the computed
        longitudinal fractions and transverse momenta. Default is True.
    quiet: bool, optional
        The longitudinal fractions and transverse momenta are returned only if
        set to True. Default is False.

    Returns
    -------
    z: array
        Array of the considered longitudinal fractions (only if *quiet* = False).
    kT: array
        Array of the considered transverse momenta (only if *quiet* = False).
    """

    if kind == "random":
        z, kT = random_sample(dp, sample_size, seed)
    elif kind == "regular":
        z, kT = regular_sample(dp, sample_size, mesh, args)
    elif kind == "cut":
        if z is not None:
            z, kT = transverse_sample(dp, sample_size, mesh, z, args)
        elif kT is not None:
            z, kT = longitudinal_sample(dp, sample_size, mesh, kT, args)
        else:
            raise DarkPhotonError("No cut coordinate provided.")
    else:
        raise DarkPhotonError("Invalid 'kind'.")

    if set_coord:
        dp.z = z
        dp.kT = kT

    if not quiet:
        return z, kT

def random_sample(dp, sample_size, seed=None):
    """
    Generate a random covering of the physical domain of the dark photon *dp*.

    Parameters
    ----------
    dp: dps.DarkPhoton
        DarkPhoton instance.
    sample_size: int
        Number of points to sample inside the physical domain.
    seed: int, optional
        Seed of the random number generator. Default is None.

    Returns
    -------
    z: array
        Array of the longitudinal fractions. Length = *sample_size*
    kT: array
        Array of the transverse momenta. Length = *sample_size*
    """

    if seed is None:
        seed = np.random.randint(0, 2**32)

    zs = list()
    kTs = list()
    batch = int(sample_size / 10)
    if batch == 0:
        batch = sample_size

    i = 0
    while True:

        np.random.seed(seed + i)
        i += 1

        z = np.random.uniform(dp.zmin, dp.zmax, batch)
        kT = np.random.uniform(0, dp.abskTmax, batch)

        yCM, xA, xB, MT, kL, Ek = utils.get_kinematics(dp.M, z, kT)
        indomain = utils.get_indomain(dp.M, kT, MT, xA, xB, yCM)

        zs = np.concatenate([zs, z[indomain]])
        kTs = np.concatenate([kTs, kT[indomain]])

        if len(zs) >= sample_size:
            break

    return zs[:sample_size], kTs[:sample_size]

def gaussian_args(dp, Nz=None, NkT=None):
    """
    Generate default values for the gaussian distribution. Parameters for *z*
    (*kT*) are returned only if *Nz* (*NkT*) is not None.

    Parameters
    ----------
    dp: dps.DarkPhoton
        DarkPhoton instance.
    Nz: int, optional
        Sample size along *z*. Default is None.
    NkT: int, optional
        Sample size along *kT*. Default is None.

    Returns
    -------
    Dictionnary of the gaussian distribution parameters.
    """

    args = dict()

    if Nz is not None:
        sigma_z = 3 * (dp.z0 - dp.zmin)
        dzmin, dzmax = get_step_limits(dp.zmin, dp.zmax, dp.z0, sigma_z, Nz)
        dz = np.min([2 * dzmin, dzmin + (dzmax - dzmin) / 2])
        args["z"] = {"step": dz , "sigma": sigma_z}

    if NkT is not None:
        sigma_kT = 3.0
        dkTmin, dkTmax = get_step_limits(0.0, dp.abskTmax, 0.0, sigma_kT, NkT)
        dkT = np.min([2 * dkTmin, dkTmin + (dkTmax - dkTmin) / 2])
        args["kT"] = {"step": dkT, "sigma": sigma_kT}

    return args

def regular_sample(dp, sample_size, mesh, args=None):
    """
    Generate a regular grid covering the physical domain of the dark photon
    *dp*.

    Parameters
    ----------
    dp: dps.DarkPhoton
        DarkPhoton instance.
    sample_size: (int, int)
        Number of points to sample along *z*, respectively *kT*.
    mesh: str
        Distribution of the points: "constant" or "gaussian".
    args: dict, optional
        Dictionnary of the arguments for the gaussian cut if *mesh* = "gaussian".
        If None, the default dictionnary generated by *gaussian_args()* is used.
        Default is None.

    Returns
    -------
    z: array
        Array of the longitudinal fractions inside the physical domain.
    kT: array
        Array of the transverse momenta inside the physical domain.
    """

    if mesh == "constant":
        Nz, NkT = sample_size
        z = np.linspace(dp.zmin, dp.zmax, Nz)
        kT = np.linspace(0, dp.abskTmax, NkT)

    elif mesh == "gaussian":

        Nz, NkT = sample_size
        if args is None:
            args = gaussian_args(dp, Nz=Nz, NkT=NkT)

        z = gradation(dp.zmin, dp.zmax, dp.z0,\
                      args["z"]["sigma"], Nz, args["z"]["step"])
        kT = gradation(0, dp.abskTmax, 0,
                       args["kT"]["sigma"], NkT, args["kT"]["step"])

    kTgrid, zgrid = np.meshgrid(kT, z)
    zs = zgrid.flatten()
    kTs = kTgrid.flatten()
    yCM, xA, xB, MT, kL, Ek = utils.get_kinematics(dp.M, zs, kTs)
    indomain = utils.get_indomain(dp.M, kTs, MT, xA, xB, yCM)

    return zs[indomain], kTs[indomain]

def transverse_sample(dp, sample_size, mesh, z, args=None):
    """
    Compute a transverse cut of *sample_size* points following the distribution
    *mesh* at fixed *z* in the phyical domain of the dark photon *dp*.

    Parameters
    ----------
    dp: dps.DarkPhoton
        DarkPhoton instance.
    sample_size: int
        Number of points to sample.
    mesh: str
        Distribution of the points: "constant" or "gaussian".
    z: float
        Longitudinal fraction of the cut.
    args: dict, optional
        Dictionnary of the arguments for the gaussian cut if *mesh* = "gaussian".
        If None, the default dictionnary generated by *gaussian_args()* is used.
        Default is None.

    Returns
    -------
    z: array
        Array of *sample_size* copies of *z*.
    kT: array
        Array of *sample_size* transverse momenta along the cut.
    """

    kTmax = dp.kTmax(z)

    if mesh == "constant":
        kT = np.linspace(0, kTmax, sample_size)

    elif mesh == "gaussian":
        if args is None:
            args = gaussian_args(dp, NkT=sample_size - 1)

        kT = gradation(0, kTmax, 0,
                       args["kT"]["sigma"], sample_size - 1, args["kT"]["step"])

    z = np.ones(sample_size) * z

    return z, kT

def longitudinal_sample(dp, sample_size, mesh, kT, args=None):
    """
    Compute a longitudinal cut of *sample_size* points following the
    distribution *mesh* at fixed *kT* in the phyical domain of the dark photon
    *dp*.

    Parameters
    ----------
    dp: dps.DarkPhoton
        DarkPhoton instance.
    sample_size: int
        Number of points to sample.
    mesh: str
        Distribution of the points: "constant" or "gaussian".
    kT: float
        Transverse momentum of the cut.
    args: dict, optional
        Dictionnary of the arguments for the gaussian cut if *mesh* = "gaussian".
        If None, the default dictionnary generated by *gaussian_args()* is used.
        Default is None.

    Returns
    -------
    z: array
        Array of *sample_size* longitudinal fractions along the cut.
    kT: array
        Array of *sample_size* copies of *kT*.
    """

    _, (zmin, zmax) = dp.get_zmin_and_zmax(kT)

    if mesh == "constant":
        z = np.linspace(zmin, zmax, sample_size)

    elif mesh == "gaussian":
        if args is None:
            args = gaussian_args(dp, Nz=sample_size - 1)

        z = gradation(zmin, zmax, dp.z0,
                      args["z"]["sigma"], sample_size - 1, args["z"]["step"])

    kT = np.ones(sample_size) * kT

    return z, kT
